#include "Price.mqh"

struct INTERVAL
{
  int Begin;
  int End;

  void Set( const int iBegin, const int iEnd )
  {
    this.Begin = iBegin;
    this.End = iEnd;

    return;
  }

  string TimeToString( const PRICE &Prices[], const int Pos ) const
  {
    return(::TimeToString(Prices[Pos].time, TIME_MINUTES) + "(" + (string)Pos + ")");
  }

  datetime GetLength( const PRICE &Prices[] ) const
  {
    return(Prices[this.End].time - Prices[this.Begin].time);
  }

  string LengthToString( const datetime Length ) const
  {
    const int Days = (int)(Length / (24 * 3600));

    return(((Days) ? (string)Days + "d ": "") + ::TimeToString(Length, TIME_MINUTES));
  }

  string ToString( const PRICE &Prices[] ) const
  {
    return(this.TimeToString(Prices, this.Begin) + "-" + this.TimeToString(Prices, this.End) + " " + this.LengthToString(GetLength(Prices)));
  }
};