#include "Interval.mqh"

#define DAY (24 * 3600)

struct RESULT
{
  int Value;

  INTERVAL Interval1;
  INTERVAL Interval2;

  void SetIntervals( const int iBegin1, const int iEnd1, const int iBegin2, const int iEnd2 )
  {
    this.Interval1.Set(iBegin1, iEnd1);
    this.Interval2.Set(iBegin2, iEnd2);

    return;
  }

  string ToString( const PRICE &Prices[] ) const
  {
    return((string)this.Value + ": " + this.Interval1.ToString(Prices) + ", " + this.Interval2.ToString(Prices));
  }

  bool operator <=( const int iValue ) const
  {
    return(this.Value <= ::MathAbs(iValue));
  }

  void operator =( const int iValue )
  {
    this.Value = ::MathAbs(iValue);

    return;
  }

  int Get( const PRICE &Prices[] )
  {
    int Res = 0;

    const int Size = ::ArraySize(Prices);

    if (Size > 1)
    {
      const int DayBars = (int)(DAY / (Prices[1].time - Prices[0].time));

      for (int _Begin1 = Interval1.Begin, _End1 = Interval1.End, _Begin2 = Interval2.Begin, _End2 = Interval2.End; _End2 < Size;
           _Begin1 += DayBars, _End1 += DayBars, _Begin2 += DayBars, _End2 += DayBars)
      {
        const double Diff = (Prices[_End1].Price - Prices[_Begin1].Price) * (Prices[_End2].Price - Prices[_Begin2].Price);

        if (Diff > 0)
          Res++;
        else if (Diff < 0)
          Res--;
      }
    }

    return(::MathAbs(Res));
  }
};

#undef DAY